#include <iostream>

#include "VectorND.h"

using namespace std;

VectorND::VectorND() {
  this->m_dCoords = NULL;
  this->m_imeret = 0;
}

VectorND::VectorND(const int m, const double *t) {
  this->m_imeret = m;

  this->m_dCoords = new double[this->m_imeret];

  for (int i = 0; i < this->m_imeret; i++)
    this->m_dCoords[i] = t[i];
}

const void VectorND::print() const {
  cout << "[";
  for (int i = 0; i < this->m_imeret; i++) {
    cout << this->m_dCoords[i];

    if (i != (this->m_imeret - 1))
      cout << ",";
  }
  cout << "]" << endl << endl;
}

void VectorND::setCoords(const int m, const double *t) {
  this->m_imeret = m;

  if (this->m_dCoords != NULL)
    delete this->m_dCoords;

  this->m_dCoords = new double[this->m_imeret];

  for (int i = 0; i < this->m_imeret; i++)
    this->m_dCoords[i] = t[i];
}

void VectorND::addVector(const VectorND &v) {
  if (this->m_imeret != v.getMeret()) {
    cout << "Nem egyforma dimenzio! " << endl;
    return;
  }

  for (int i = 0; i < this->m_imeret; i++)
    this->m_dCoords[i] += v.getICoord(i);
}

VectorND &VectorND::operator+(const VectorND &other) const {
  if (this->m_imeret != other.getMeret()) {
    VectorND *vector = new VectorND;
    return *vector;
  }

  double *tmp = new double[this->m_imeret];
  for (int i = 0; i < this->m_imeret; i++)
    tmp[i] = this->m_dCoords[i] + other.m_dCoords[i];

  VectorND *vector = new VectorND(this->m_imeret, tmp);

  delete[] tmp;

  return *vector;
}

VectorND &VectorND::operator+(const double other) const {
  double *tmp = new double[this->m_imeret];
  for (int i = 0; i < this->m_imeret; i++)
    tmp[i] = this->m_dCoords[i] + other;

  VectorND *vector = new VectorND(this->m_imeret, tmp);

  delete[] tmp;

  return *vector;
}